-- $Rev: 31 $
RepaFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0", "AceEvent-2.0")
local RepaFu, self = RepaFu, RepaFu
RepaFu.hasIcon = "Interface\\AddOns\\FuBar_RepaFu\\icon.tga"
RepaFu.cannotDetachTooltip = true
RepaFu.defaultPosition = "RIGHT"
RepaFu.tooltipType = "Tablet-2.0"
RepaFu.clickableTooltip = true
RepaFu.date = string.sub("$Date: 2009-10-06 11:54:19 +0000 (Tue, 06 Oct 2009) $", 8, 17)
RepaFu.revision = tonumber(string.sub("$Revision: 31 $", 12, -3))
RepaFu.version = "v3.2-r" .. RepaFu.revision

local L = AceLibrary("AceLocale-2.2"):new("FuBar_RepaFu")
local _G = _G
local select = select
local string_format = string.format
--
local Tablet = AceLibrary("Tablet-2.0")
--
local GetNumFactions = _G.GetNumFactions
local GetFactionInfo = _G.GetFactionInfo
local print = _G.print
local table_insert=_G.table.insert
local table_sort=_G.table.sort


function RepaFu:OnInitialize()
	self:RegisterDB("RepaFuDB")
	self:RegisterDefaults('profile', {
		order = "1",
		field = "1",
		check="1",
	})
end

RepaFu.OnMenuRequest = {
	type = 'group',
	args = {
		gsort = {
			type = "group",
			name = L["Sort"],
			desc = L["Sorting_Type"],
			args = {
				sorters = {
					type = "text",
					name = L["Order"],
					desc = L["Order"],
					get = function() return RepaFu.db.profile.order end,
					set = function(v) RepaFu.db.profile.order = v end,
					validate = {
						["0"]=L["None"],
						["1"]=L["Asc"],
						["2"]=L["Desc"]
					},
				},
				fields = {
					type = "text",
					name = L["Field"],
					desc = L["Field"],
					get = function() return RepaFu.db.profile.field end,
					set = function(v) RepaFu.db.profile.field = v end,
					validate = {
						["0"]=L["Factions"],
						["1"]=L["Reputation"],
						["2"]=L["Left"]
					},
				},
			},
		},
	},
}

function RepaFu:OnEnable()
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
	self:Update()
end

function RepaFu:CHAT_MSG_COMBAT_FACTION_CHANGE()
	self:Update()
end

function RepaFu:OnTextUpdate()
	local _, _, _,bottomValue,topValue, earnedValue,_,_, isHeader,_,_,_,_ = GetFactionInfo(RepaFu.db.profile.check)
	if isHeader==nil then
		if earnedValue~=nil then
			self:SetText((earnedValue-bottomValue).."/"..(topValue-bottomValue))
		else
			self:SetText("Repa")
		end
	else
		self:SetText("Repa")
	end
end

function RepaFu:OnTooltipUpdate()
	
	local t={}
	Tablet:SetHint("enjoy")
	local supercat = Tablet:AddCategory(
		'columns', 4,
		'hideBlankLine', true
	)
   	supercat:AddLine(
		'text', L["Factions"],
		'text2', L["Reputation"],
		'text3', L["Left"],
		'justify','center',
		'justify2','center',
		'justify3','center',
		'wrap',true,
		'textR',1,
		'textG',0,
		'textB',0,
		'text2R',1,
		'text2G',0,
		'text2B',0,
		'text3R',1,
		'text3G',0,
		'text3B',0
	)
	for i=1,GetNumFactions() do
		local fname, _, _,bottomValue,topValue, earnedValue,_,_, isHeader,_,_,_,_ = GetFactionInfo(i)
		local tmptxt=(earnedValue-bottomValue).."/"..(topValue-bottomValue)
		if isHeader==nil then
			table_insert(t,{a=i,b=earnedValue,c=bottomValue,d=topValue,e=fname})
		end
		table_sort(t, function (a, b) 
			if (RepaFu.db.profile.order=="0") then
				return false 
			elseif (RepaFu.db.profile.order=="1") then 
				if (RepaFu.db.profile.field=="0") then
					return a.e<b.e
				elseif (RepaFu.db.profile.field=="1") then
					return a.b<b.b 
				elseif (RepaFu.db.profile.field=="2") then
					return (a.d-a.b)<(b.d-b.b)
				end
			elseif (RepaFu.db.profile.order=="2") then 
				if (RepaFu.db.profile.field=="0") then
					return a.e>b.e
				elseif (RepaFu.db.profile.field=="1") then
					return a.b>b.b 
				elseif (RepaFu.db.profile.field=="2") then
					return (a.d-a.b)>(b.d-b.b)
				end
			end 
		end)
	end
	for _, data in ipairs(t) do
		local r,g,b
		if ((data.d-data.c)==3000) then
			r=1
			g=1
			b=0
		elseif ((data.d-data.c)==6000) then
			r=0
			g=0.5
			b=0
		elseif ((data.d-data.c)==12000) then
			r=0
			g=1
			b=0
		elseif ((data.d-data.c)==21000) then
			r=0.9
			g=0.8
			b=0.5
		end
		supercat:AddLine(
			'text',data.e,
			'text2',(data.b-data.c).."/"..(data.d-data.c),
			'text3',(data.d-data.b),
			'text2R',r,
			'text2G',g,
			'text2B',b,
			'justify','left',
			'justify2','right',
			'justify3','right',
			'wrap',true,
			'func','OnFRClick',
			'arg1',self,
			'arg2',data.a
		)
	end
end

function RepaFu:OnClick()
end

function RepaFu:OnFRClick(id)
		RepaFu.db.profile.check=id
		self:Update()
end
